function WBD=BD_white2_7_00(Hs,k,N,m,p,LAMBDAu)

% compute pre-whitening filter to estimate (B,D)

Ruh = LAMBDAu(1:k*m,1:k*m);
ru = k*m;
i=1;

for j = 1:k*p,
      Phi2h((j-1)*ru+1:j*ru,(i-2+j)*ru+1:(i-1+j)*ru)=Ruh;
  end;

for i=2:k,
   Ruuh = (1 - (i-1)/N)*LAMBDAu((i-1)*m+1:(i-1+k)*m,1:k*m);
   Ruuh = kron(eye(p),Ruuh);
   for j = 1:(k-i+1),
      Phi2h((j-1)*p*ru+1:j*p*ru,(i-2+j)*p*ru+1:(i-1+j)*p*ru)=Ruuh;
      Phi2h((i-2+j)*p*ru+1:(i-1+j)*p*ru,(j-1)*p*ru+1:j*p*ru)=Ruuh';
   end;
   
end;

Q = kron(eye(ru),Hs);
WBD = Q*Phi2h*Q';
WBD = N*inv((WBD+0.000002*eye(size(WBD))));
