function WBD=BD_swhite_7_00(Gperp,VV,W,m,p)

% compute pre-whitening filter to estimate (B,D)

[rgp,cgp]=size(Gperp);
W = Gperp*W;
U = VV';
Ru=U*U';
Rw=W*W';

[ru cu]=size(U);
[rw cw]=size(W);
k=round(ru/m);
Phi2 = kron(Rw,Ru);

for i=2:k,
   Ruu = U(:,i:cu)*U(:,1:cu-i+1)'; %*cu/(cu-i+1);
   Rww = W(:,i:cw)*W(:,1:cw-i+1)'; % *cw/(cw-i+1);
   Kr2 = kron(Rww,Ruu);
   Phi2 = Phi2+Kr2+Kr2';
end;

[U S V]=svd(Phi2);
WBD = pinv(sqrt(S))*U';

%WDB = real(inv(chol(Phi2)'));
%keyboard
