function WBD=BD_white_11_00(k,N,m,p,LAMBDAu,UUUT)

% compute pre-whitening filter to estimate (B,D)

Ruh = LAMBDAu(1:k*m,1:k*m);
ru = k*m;
i=1;

for j = 1:k*p,
      Phi2h((j-1)*ru+1:j*ru,(i-2+j)*ru+1:(i-1+j)*ru)=eye(size(Ruh)) ;
  end;
  [U S V]=svd(Ruh);
  pRuh = pinv(UUUT);
for i=2:k,
   Ruuh = (1 - (i-1)/N)*pRuh*LAMBDAu((i-1)*m+1:(i-1+k)*m,1:k*m)*pRuh';
   Ruuh = kron(eye(p),Ruuh);
   for j = 1:(k-i+1),
      Phi2h((j-1)*p*ru+1:j*p*ru,(i-2+j)*p*ru+1:(i-1+j)*p*ru)=Ruuh;
      Phi2h((i-2+j)*p*ru+1:(i-1+j)*p*ru,(j-1)*p*ru+1:j*p*ru)=Ruuh';
   end;
   
end;


WBD = N*inv((Phi2h+0.00002*eye(size(Phi2h))));
