% file test
clear all
close all


zs = [-j*.99 j*.99];
ps = [-.9 .9];
Kstoc = 1;

zu = [-.9];
pu = [.9];
Ku = 1;

zd = [];
pd = [.5];
Kd = 1;

G = zpk(zs,ps,Kstoc,1);
Hu = zpk(zu,pu,Ku,1);
F = zpk(zd,pd,Kd,1);

M =ss([F G]);
A = M.a;
BB = M.b;
K1 = BB(:,2);
B = BB(:,1);
C = M.c;
DD = M.d;
D = DD(1);
Lambda = DD(2)^2;
K = K1/DD(2);

MM = idss(A,B,C,D,K,zeros(3,1),1);

seed1 = 10000*rand;
seed2 = randn;
sim('generatore_dati',[1:3000]);

y = y(2000:3000,:);
ys = ys(2000:3000,:);
u = u(2000:3000,:);
yd = yd(2000:3000,:);

[As,Ks,Cs,Lambda]=stoc_est_cva(ys',[10 10],[1:10]);

Ghat = ss(As,Ks*sqrt(Lambda),Cs,sqrt(Lambda),1);

[Ado,Bdo,Cdo,Ddo,Aso,Kso,Cso,Lambdao]=ort_dec(y',u',[1:10],[1:10],10,[10 10],'ls',[],1,'cva','ls');

Ghato = ss(Aso,Kso*sqrt(Lambdao),Cso,sqrt(Lambdao),1);

Fhato = ss(Ado,Bdo,Cdo,Ddo,1);

[Aj,Bj,Cj,Dj,Kj,Lambdaj]=subspace_id(y',u',[1:10],[1:10],10,'proj_ls',[],1,'cva','ls');

Ghatj = ss(Aj,Kj*sqrt(Lambdaj),Cj,sqrt(Lambdaj),1);

Fhatj = ss(Aj,Bj,Cj,Dj,1);


dat = iddata(y,u,1);
dats = iddata(ys,[],1);
Model = n4sid(dat,[1:10],'N4Weight','CVA')
Am = Model.A;
Bm = Model.B;
Cm = Model.C;
Dm = Model.D;
Km = Model.K;

Models = n4sid(dats,[1:10],'N4Weight','CVA')
Asm = Models.A;
Csm = Models.C;
Ksm = Models.K;

etrue = pe(MM,dat,'e');
etrue = etrue.outputdata;
Lambdat = etrue'*etrue/length(etrue);
e = pe(Model,dat,'e');
e = e.outputdata;


Lambdam = e'*e/length(e);


Ghatm = ss(Am,Km*sqrt(Lambdam),Cm,sqrt(Lambdam),1);

Fhatm = ss(Am,Bm,Cm,Dm,1);

ModelJ = idss(Aj,Bj,Cj,Dj,Kj);

Resid(ModelJ,dat)
compare(dat,ModelJ,1)